<?php

class stMigrationCategory extends stMigrationModel
{
    protected $rootCategory = null;

    public function setMCategory($category, $category_id, $name)
    {
        $root = stMigrationSoteshopHelper::getRootCategory();

        $this->update($category, $name);
        
        $root = $root->reload();
        
        $category->insertAsLastChildOf($root);
        
        $category->save();   

        appMigrationWoocommerceHelper::addRelation($category_id, $category->getId(), 'category'); 

        $this->importRecursive($category_id, $category);       

    }  

    protected function importRecursive($parent_id, $root)
    {
        $rs = $this->getDataRetriever()->executeQuery('SELECT t.term_id, t.name FROM wp_terms t, wp_term_taxonomy tt WHERE tt.parent ='.$parent_id.' AND tt.term_id = t.term_id ORDER BY t.name ASC;');

        $categories = array();

        while($rs->next())
        {
            $row = $rs->getRow();

            $category = new Category();
            
            $this->update($category, $row['name']);

            $category->insertAsLastChildOf($root);
            
            $category->save();
            
            appMigrationWoocommerceHelper::addRelation($row['term_id'], $category->getId(), 'category');

            $categories[$row['term_id']] = $category;
        }

        foreach ($categories as $parent_id => $root)
        {
            $root = $root->reload();
            $this->importRecursive($parent_id, $root);
        }
    }

    protected function update(Category $category, $name)
    {
        $category->setCulture(stLanguage::getOptLanguage());
        $category->setName($name);
    }

}