<?php


class stMigrationProduct extends stMigrationModel
{
    protected static $filter = null;

    protected $images = array();

    protected $id = null;

    protected $categories = array();

    public function postCreate($product)
    {
        $product->setCulture('pl_PL');
    }

    public function setMId($product, $id)
    {
        $this->id = $id;
    }

    public function setMCode($product, $id)
    {
        
        $code = "NOSKU_".uniqid();

        $product->setCode($code);


        $stm = $this->getDataRetriever()->prepareStatement("SELECT meta_value as code FROM wp_postmeta WHERE post_id = ".$id." AND meta_key = '_sku' ");

        $result = $stm->executeQuery();
        
        while ($result->next()){

            $value = $result->getString('code');

            if ($value)
            {
                
                $c = new Criteria();

                $c->add(ProductPeer::CODE, $value);

                $same_product = ProductPeer::doSelectOne($c);
                

                if($same_product){
                    
                    $product->setCode($same_product->getCode().'_DUP_'.uniqid());     
                    
                }else{
                    
                    $product->setCode($value);                    
                    
                }
                
            }

        }
        
    }

    public function setMUom($product, $id)
    {

        $stm = $this->getDataRetriever()->prepareStatement("SELECT name FROM wp_term_relationships tr, wp_term_taxonomy tt, wp_terms t WHERE tr.term_taxonomy_id = tt.term_taxonomy_id AND t.term_id = tt.term_id AND tt.taxonomy = 'pa_pojemnosc' AND tr.object_id = ".$id);

        $result = $stm->executeQuery();

        while ($result->next()) { 

            $uom = $result->getString('name');

        }

        $product->setUom($uom);  
    }

    public function setMDescription($product, $description)
    {
        $description = stripslashes($description);

        $description = str_replace('/images/', '/uploads/images/', $description);

        $product->setDescription($description);
    }

    public function setMName($product, $name)
    {
   
        $product->setCulture('pl_PL');
        
        $product->setName($name);

    }

    public function setMPrice($product, $id)
    {

        $stm = $this->getDataRetriever()->prepareStatement("SELECT meta_value as price FROM wp_postmeta WHERE post_id = ".$id." AND meta_key = '_price' ");

        $result = $stm->executeQuery();
        
        while ($result->next()) { 

            $price = $result->getString('price');

        }
        
        $data_retriver = $this->getDataRetriever();        
        
        $woo_tax_value = $data_retriver->databaseConnectionParams['woo_tax'];
        

        $product->setPriceNetto(null);

        $product->setPriceBrutto($price);            
        
        
        $ct = new Criteria();

		$ct->add(TaxPeer::VAT, $woo_tax_value);

		$tax = TaxPeer::doSelectOne($ct);

		if (!is_object($tax)) {
			$tax = new Tax();

			$tax->setVat($woo_tax_value);

			$tax->setVatName($woo_tax_value.'%');

			$tax->save();
		}

		$product->setTax($tax);

		$product->setOptVat($woo_tax_value);

        $product->setAvailabilityId('2');

    }

    public function setMCreatedAt($object, $v)
    {
        if (strtotime($v)===false)  $object->setCreatedAt(time());
        else $object->setCreatedAt($v);
    }

    public function setMImage($product, $id)
    {
        $product->mImageFiles = array();

        $stm = $this->getDataRetriever()->prepareStatement("SELECT p.ID, CONCAT((SELECT option_value FROM wp_options o WHERE o.option_name = 'siteurl'), '/wp-content/uploads/', am.meta_value) AS siteurl FROM wp_posts p LEFT JOIN wp_postmeta pm ON pm.post_id = p.ID AND pm.meta_key = '_thumbnail_id' LEFT JOIN wp_postmeta am ON am.post_id = pm.meta_value AND am.meta_key = '_wp_attached_file' WHERE p.post_type = 'product' AND p.post_status = 'publish' AND am.meta_value IS NOT NULL AND p.ID = ".$id );

        $result = $stm->executeQuery();
        
        while ($result->next()){

            $image = $result->getString('siteurl');

            $this->getLogger()->info(sprintf('Przenosze zdjęcia z produktu o id "%s" do produktu o kodzie "%s"', $id, $product->getCode()));

            $image_path = $this->uploadImage($image);
                
            if (!empty($image_path))
            {
                $product->mImageFiles[] = $image_path;
            }

            usleep(2000);
        }
        
        
        
        $data_retriver = $this->getDataRetriever();        
        
        $woo_photo_value = $data_retriver->databaseConnectionParams['woo_photo'];
        
        if($woo_photo_value == "all")
        {                                                            

            $stm = $this->getDataRetriever()->prepareStatement("SELECT guid as image FROM wp_posts WHERE post_parent = ".$id." AND post_type = 'attachment' ");

            $result = $stm->executeQuery();
            
            while ($result->next()){
                    
                $image = $result->getString('image');

                $this->getLogger()->info(sprintf('Przenosze zdjęcia z produktu o id "%s" do produktu o kodzie "%s"', $id, $product->getCode()));

                $image_path = $this->uploadImage($image);
                    
                if (!empty($image_path))
                {
                    $product->mImageFiles[] = $image_path;
                }

                usleep(2000);
            }
            
        }
        
    }

    public function postSave($product, $con = null)
    {
        $default = true;
        
        foreach ($product->mImageFiles as $image)
        {
            $this->addImageToProduct($product, $image, $default, $con);

            $default = false;
        }

    }

    protected function addImageToProduct($product, $image, $default = false, $con = null)
    {
        $product_has_asset = new ProductHasSfAsset();

        $product_has_asset->setIsDefault($default);

        $product_has_asset->setProduct($product);

        $product_has_asset->createAsset(basename($image), $image, ProductHasSfAssetPeer::IMAGE_FOLDER);

        $product_has_asset->save($con);
        
        $this->getLogger()->warning(sprintf('Dodano obraz do produktu "%s" ', $image));
    }


    public function uploadImage($url)
    {
        static $b = null;

        if (is_null($b))
        {
            $b = new sfWebBrowser(array(), 'sfCurlAdapter');
        }

        $content = $b->get($url);

        if ($content->getResponseCode() == 200)
        {
            $image_data = $content->getResponseText();

            $pathinfo = pathinfo($url);

            $filename = stMigrationSoteshopHelper::fixString(rawurldecode($pathinfo['basename'])).uniqid().'.'.$pathinfo['extension'];

            $image_file = sfConfig::get('sf_upload_dir') . DIRECTORY_SEPARATOR . $filename;

            if (file_put_contents($image_file, $image_data))
            {
                    $this->getLogger()->warning(sprintf('Obraz "%s" ', $image_file));
                        
                    return $image_file;
                
            }
            
        }
        elseif ($content->getResponseCode() != 200)
        {
            $this->getLogger()->warning(sprintf('Obraz "%s" nie istnieje', $url));
        }
        else
        {
            $this->getLogger()->notice(sprintf('Obraz "%s" [%s] nie posiada formatu jpg, gif lub png', $url, $content->getResponseHeader('content-type')));
        }

        return null;
    }

    public function setMCategory($product, $id)
    {        
        $rs = $this->getDataRetriever()->executeQuery("SELECT term_id as category_id FROM wp_term_relationships wtr, wp_term_taxonomy wtt WHERE wtr.object_id =".$id." AND wtr.term_taxonomy_id = wtt.term_taxonomy_id AND wtt.taxonomy = 'product_cat' ");

        while($rs->next())
        {
            $row = $rs->getRow();
            $category_id = appMigrationWoocommerceHelper::getRelation($row['category_id'], 'category'); 
            if ($category_id)
            {
                $this->addProductToCategory($product, $category_id);
            }
        }
    }   

    protected function addProductToCategory($product, $category_id)
    {
        $product_has_category = new ProductHasCategory();
        
        $product_has_category->setCategoryId($category_id);
        
        $product->addProductHasCategory($product_has_category);
    } 

}