<?php
/** 
 * SOTESHOP/stMigrationSoteshopPlugin 
 * 
 * Ten plik należy do aplikacji stMigrationSoteshopPlugin opartej na licencji (Professional License SOTE). 
 * Nie zmieniaj tego pliku, jeśli chcesz korzystać z automatycznych aktualizacji oprogramowania. 
 * Jeśli chcesz wprowadzać swoje modyfikacje do programu, zapoznaj się z dokumentacją, jak zmieniać 
 * oprogramowanie bez zmiany kodu bazowego http://www.sote.pl/modifications
 * 
 * @package     stMigrationSoteshopPlugin
 * @subpackage  libs
 * @copyright   SOTE (www.sote.pl)
 * @license     http://www.sote.pl/license/sote (Professional License SOTE)
 * @version     $Id: stMigrationsfGuardUser.class.php 704 2009-09-22 12:52:40Z marcin $
 */
 
/** 
 * Klasa odpowiadająca za obsługę procesu migracji
 *
 * @author Marcin Butlak <marcin.butlak@sote.pl>
 * @package     stMigrationSoteshopPlugin
 * @subpackage  libs
 */
class stMigrationsfGuardUser extends stMigrationModel
{
    protected $billing = null;
    
    protected $delivery = null;
    
    public function postCreate($user)
    {
        $user->setIsConfirm(true);
        
        $user->setIsActive(true);
    }
    
    public function postSave($user, $con = null)
    {
        if ($this->billing)
        {
            $this->billing->setsfGuardUser($user);
            
            $this->billing->save($con);
        }
        
        if ($this->delivery)
        {
            $this->delivery->setsfGuardUser($user);
            
            $this->delivery->save($con);
        }
        
        $user->addGroupByName('user');
    }

    public function validateFillin($user, $data = array())
    {
        $c = new Criteria();
        
        $c->add(sfGuardUserPeer::USERNAME, $data['email']);
        
        return !sfGuardUserPeer::doCount($c);
    }
    
    public function setMUsername($user, $username)
    {
        $user->setUsername($username);
    }
    
    public function setMPassword($user, $password)
    {
        $user->setPasswordHash($password);
        
        $user->setSalt('oCEv7Nzx6LreLxcqWYAC2ANxdqiKQFdAQ5VDyxagHudT1K5jNjf5qxa5');
        
        $user->setAlgorithm('md5');
    }
    
    public function setMUserData($user, $id)
    {

        $stm = $this->getDataRetriever()->prepareStatement("SELECT meta_key, meta_value FROM `wp_usermeta` WHERE `user_id` = ".$id." ");

        $rs = $stm->executeQuery();

        $users = array();

        while($rs->next())
        {
            $row = $rs->getRow();

            $users[$row['meta_key']] = $row['meta_value'];

        }

        $this->billing = new UserData();
        
        $this->billing->setIsBilling(true);
        
        $this->billing->setIsDefault(true);

        $this->billing->setCompany($users['billing_company']);

        $this->billing->setFullname($users['billing_first_name'].' '.$users['billing_last_name']);

        $this->billing->setAddress($users['billing_address_1'].' '.$users['billing_address_2']);
        
        $this->billing->setCode($users['billing_postcode']);
        
        $this->billing->setTown($users['billing_city']);

        $this->billing->setVatNumber($users['billing_nip']);
        
        $country = $this->retrieveCountryByName('Polska');
        
        $this->billing->setCountries($country);
        
        $this->billing->setPhone($users['billing_phone']);
        
        $this->delivery = new UserData();

        $this->delivery->setIsBilling(false);

        $this->delivery->setIsDefault(true);

        $this->delivery->setCompany($users['billing_company']);

        $this->delivery->setFullname($users['billing_first_name'].' '.$users['billing_last_name']);

        $this->delivery->setAddress($users['billing_address_1'].' '.$users['billing_address_2']);

        $this->delivery->setCode($users['billing_postcode']);

        $this->delivery->setTown($users['billing_city']);

        $this->delivery->setVatNumber($users['billing_nip']);

        $country = $this->retrieveCountryByName('Polska');

        $this->delivery->setCountries($country);

        $this->delivery->setPhone($users['billing_phone']);

    }
    
    protected function retrieveCountryByName($name)
    {
        $c = new Criteria();
        
        $c->add(CountriesI18nPeer::NAME, $name);
        
        $c->add(CountriesI18nPeer::CULTURE, 'pl_PL');
        
        $countries = CountriesPeer::doSelectWithI18n($c);
        
        return isset($countries[0]) ? $countries[0] : CountriesPeer::retrieveByPk(36);
    }
    
    public function setMCreatedAt($object, $v)
    {
        if (strtotime($v)===false)  $object->setCreatedAt(time());
        else $object->setCreatedAt($v);
    }    
}
?>
